ZAPInit()

Global LightX.f, LightY.f, LightZ.f, LightRot.f

ID = ZAPCreate(100, 100, 640, 480, #PB_Window_SizeGadget | #PB_Window_TitleBar, "ZAP-3DEngine") ;ffne ein OpenGLFenster/open a OpenGLWindow

X.f
Y.f
Z.f
AngleX.f
AngleY.f
AngleZ.f
PI.f = ATan(1)*4

Dim RoboMesh.l(2)

;-Animload
RoboMesh(0) = ZAPLoadMesh("Robot01.zm", 0.0, 0.0, 0.0, 1.5, 1.5, 1.5, 90.0, 0.0, 45.0)
RoboMesh(1) = ZAPLoadMesh("Robot02.zm", 0.0, 0.0, 0.0, 1.5, 1.5, 1.5, 90.0, 0.0, 45.0)
RoboMesh(2) = ZAPLoadMesh("Robot03.zm", 0.0, 0.0, 0.0, 1.5, 1.5, 1.5, 90.0, 0.0, 45.0)

;-Transparency
ZAPSetMeshTransparentState(RoboMesh(0), 1)
ZAPSetMeshTransparentState(RoboMesh(1), 1)
ZAPSetMeshTransparentState(RoboMesh(2), 1)

CreateImage(0, 128, 128)
StartDrawing(ImageOutput())
Box(0, 0, 128, 128, RGB(255, 0, 0))
StopDrawing()

GroundMesh = ZAPLoadMesh("cube.zm", 0.0, -1.5, 0.0, 10.0, 0.25, 10.0, 0.0, 0.0, 0.0)
RoboTex = ZAPLoadTexture("tex.bmp", 0)
GroundTex = ZAPLoadTexture("tex1.bmp", 2)
SkyTex = ZAPLoadTexture("sky.bmp", 2)

Light0 = ZAPCreateLight(0.0, 0.0, 0.0, 1.0, $FFFFFF)
Light1 = ZAPCreateLight(0.0, 0.0, -0.5, 1.0, $FFFFFF)

OldMouseX = WindowMouseX()
OldMouseY = WindowMouseY()

RoboFrame.f = 0.0

Repeat
  RoboFrame + 0.05
  If RoboFrame >= 3
    RoboFrame - 3
  EndIf
  FPS = ZAPGetFPS()
  Time.f = 0.5/FPS
  If Time.f >= 1.0 ;Timebased Movement shouldn't be so fast
    Time.f = 1.0
  EndIf
  If FPS >= 0
    SetWindowTitle(0, "ZAP-3DEngine  "+Str(FPS))
  EndIf
  If AngleY <= 0
    AngleY + 360
  ElseIf AngleY > 360
    AngleY - 360
  EndIf
  ZAPClearBuffers(ID)
  ZAPSetCamera(45, X, Y, Z-3, AngleX, AngleY, 0, 0.01, 500.0)
  ZAPGlobalTexture(0.0, 0.0, 3.0, 7.0)
  ZAPDrawSky(SkyTex, 0.005)
  ZAPGlobalTexture(0.0, 0.0, 3.0, 3.0)
  
  ZAPUseTexture(GroundTex)
  ZAPDrawMesh(GroundMesh)
  
  ZAPUseTexture(RoboTex)
  ZAPDrawMesh(RoboMesh(Int(RoboFrame)))
  ZAPMoveMesh(GroundMesh, 0, 0.01, 0, 0)
  ZAPFlipBuffers(ID)
  Event = WindowEvent()
  Select Event
    Case #WM_MOUSEMOVE
      MouseX.f = (WindowMouseX()-OldMouseX)
      MouseY.f = (WindowMouseY()-OldMouseY)
      OldMouseX = WindowMouseX()
      OldMouseY = WindowMouseY()
      AngleX + MouseY
      AngleY + MouseX
    Case #WM_KEYDOWN
      Select EventwParam()
        Case #VK_ESCAPE
          Quit = 1
        Case #VK_UP
          Z + Cos(AngleX/180*PI)*Cos(AngleY/180*PI)*0.025
          Y + Sin(AngleX/180*PI)*0.025
          X - Sin(AngleY/180*PI)*Cos(AngleX/180*PI)*0.025
        Case #VK_DOWN
          Z - Cos(AngleX/180*PI)*Cos(AngleY/180*PI)*0.025
          Y - Sin(AngleX/180*PI)*0.025
          X + Sin(AngleY/180*PI)*Cos(AngleX/180*PI)*0.025
      EndSelect
  EndSelect
Until Quit = 1
End
; ExecutableFormat=
; CursorPosition=2
; FirstLine=1
; DisableDebugger
; EOF