;Test it, press C to change view

ZAPInit()

Structure Vector
  X.f
  Y.f
  Z.f
  Time.l
EndStructure

NewList Part.Vector()

If MessageRequester("Fullscreen", "Would you like starting in fullscreen-mode?", #PB_MessageRequester_YesNo) = 6
ZAPID = ZAPCreate(0, 0, 0, 0, #PB_Window_BorderLess | #PB_Window_ScreenCentered, "Zap3D - Scene")
ShowCursor_(0)
Else
ZAPID = ZAPCreate(0, 0, 640, 480, #PB_Window_BorderLess | #PB_Window_ScreenCentered, "Zap3D - Scene")
EndIf

X.f
Y.f
Z.f
AngleX.f
AngleY.f
AngleZ.f
piover180.f = (ATan(1)*4)/180

ActivateWindow()

Light0 = ZAPCreateLight(0.0, 1.0, 0.0, 0.5, RGB(255, 255, 200))
Light1 = ZAPCreateLight(0.5, 0.0, 0.0, 0.5, RGB(255, 255, 200))

Ship = ZAPLoadMesh("ship.zm", 0, -0.5, 0, 1, 1, 1, 0, 0, 0)
Wall = ZAPLoadMesh("cube.zm", -1.0, -0.5, 0, 1, 1, 3.0, 0, 0, 0)
Tex0 = ZAPLoadTexture("tex0.bmp", 0)
Tex1 = ZAPLoadTexture("tex1.bmp", 2)

Speed.f = 0.2

Repeat
  ZAPClearBuffers(ZAPID)
  If Camera = 0
  ZAPSetCamera(45, -ZAPGetMeshX(Ship) + Sin(AngleY*piover180)*2, -0.5, -ZAPGetMeshZ(Ship) - Cos(AngleY*piover180)*2, 15, AngleY, 0, 0.01, 50.0)
  Else
  ZAPSetCamera(45, -ZAPGetMeshX(Ship), -3.5, -ZAPGetMeshZ(Ship), 85, 0.0, 0, 0.01, 50.0)
  EndIf
  ZAPUseTexture(Tex1)
  ZAPDrawMesh(Wall)
  ZAPUseTexture(Tex0)
  ZAPMoveMesh(Ship, Sin(AngleY*piover180)*Speed.f/500, 0.0, -Cos(AngleY*piover180)*Speed.f/500, 0)
  ZAPDrawMesh(Ship)
  ZAPFlipBuffers(ZAPID)
  If GetAsyncKeyState_(#VK_ESCAPE)
    Quit = 1
  EndIf
  If GetAsyncKeyState_(#VK_UP)
    If Speed < 2.0
      Speed + 0.001
    EndIf
  ElseIf GetAsyncKeyState_(#VK_DOWN)
    If Speed > 0.2
      Speed - 0.001
    EndIf
  EndIf
  If GetAsyncKeyState_(#VK_LEFT)
    AngleY - 0.125
    If AngleZ >= -45.0
      AngleZ - 0.25
    EndIf
  ElseIf GetAsyncKeyState_(#VK_RIGHT)
    AngleY + 0.125
    If AngleZ <= 45.0
      AngleZ + 0.25
    EndIf
  Else
    If AngleZ < 0
      AngleZ + 0.25
    ElseIf AngleZ > 0
      AngleZ - 0.25
    EndIf
  EndIf
  ZAPRotateMesh(Ship, 0.0, AngleY, AngleZ)
  Event = WindowEvent()
  Select Event
    Case #WM_KEYDOWN
      Select EventwParam()
        Case #VK_C
          If Camera = 0
          Camera = 1
          Else
          Camera = 0
          EndIf
      EndSelect
  EndSelect
Until Quit = 1
End
; ExecutableFormat=
; FirstLine=1
; EOF